import javax.microedition.midlet.*;
import org.eclipse.ercp.swt.mobile.Command;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;

public class $class_name$ extends MIDlet implements Runnable, SelectionListener, PaintListener {

	Thread UIThread;
	Display display;
	Shell shell;
	Color myColor;

	public void startApp() {
		// Create the eSWT UI thread. 
		if(UIThread == null) {
			UIThread = new Thread(this);
			UIThread.start();
		}
	}

	public void pauseApp() {
		// Here we could reduce the resources but we should keep the Display instance
		// and the eSWT UI Thread. 
	}

	public void destroyApp(boolean unconditional) {
		// Dispose the resources owned. 
		myColor.dispose();
		// Dispose the remaining resources. 
		display.dispose();
	}

// The eSWT UI Thread	
	public void run() {
		// Create the Display. 
		display = new Display();
		
		shell = new Shell(display);
		shell.open();
		
		Command exitCommand = new Command(shell, Command.EXIT, 0);
		exitCommand.setText("Exit");
		exitCommand.addSelectionListener(this);

		// Allocate some resources that we will own. 
		myColor = new Color(display, 100, 100, 0);
		
		// Print the hello world greeting.
		shell.addPaintListener(this);
		shell.redraw();

		// Execute the eSWT event loop. 
		while(!shell.isDisposed()) {
			if(!display.readAndDispatch()) {
				display.sleep();
			}
		}
		// Clean up and destroy the MIDlet
		destroyApp(true);
		notifyDestroyed();
	}
	
	public void widgetDefaultSelected(SelectionEvent e) {
	}

	public void widgetSelected(SelectionEvent e) {
		// Exit command selected, exit the event loop. 
		shell.dispose();
	}

	public void paintControl(PaintEvent e) {
		// Print a hello world greeting using the custom color resource. 
		e.gc.setForeground(myColor);
		e.gc.drawText("$message$", 0, 0, SWT.DRAW_TRANSPARENT);
	}
}
